local AutoZoomOut = {} 
_G["AutoZoomOut"] = AutoZoomOut;
local AZOframe

local AZOCounter=0
local AZOLastDistance=0




function AutoZoomOut:OnLoad(self)
	AZOframe=self
	AZOframe:RegisterEvent("VARIABLES_LOADED")
	
	SlashCmdList["AUTOZOOMOUTCMD"] = AutoZoomOut.SlashCommand;
	_G["SLASH_AUTOZOOMOUTCMD1"] = "/azo";

end


function AutoZoomOut:OnEvent(self, event, arg1, arg2)
    if event == "VARIABLES_LOADED" then
		if AutoZoomOutData==nil then
			AutoZoomOutData = {}
			AutoZoomOutData.Enabled=true
			AutoZoomOutData.Distance=150
			AutoZoomOutData.Debug=false
			AutoZoomOutData.Sensitivity=3
			AutoZoomOutData.CycleDelay=10
			AutoZoomOutData.FreezeCamera=false
		end	
	
		SaveVariables("AutoZoomOutData")
	
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut loaded. Use /azo h for Help.")
	end
	
end


function AutoZoomOut:IsInHouse()
	local InHouse=false
	local i=1;
	while( UnitDebuff("player", i) ~= nil ) do
		if (string.find (string.lower(UnitDebuff("player", i)), "wohlbehalten") ~= nil 
			or string.find (string.lower(UnitDebuff("player", i)), "safe and sound") ~= nil) then
			InHouse = true;
		end
		i=i+1;
	end
	if AutoZoomOutData.Debug then
		if InHouse then
			DEFAULT_CHAT_FRAME:AddMessage("AutozoomOut: Player is in his hosue.")
		end
	end
	return Inhouse;
end


function AutoZoomOut:Print()

	local CameraPosition = {x=0,z=0,y=0}
	local PlayerPosition = {x=0,z=0,y=0}
	local CameraUpVector = {x=0,z=0,y=0}
	local CameraVector   = {x=0,z=0,y=0}
	local CameraNormalVector  = {x=0,z=0,y=0}
	local CameraDistance = 0
	
	
	CameraPosition.x,CameraPosition.z,CameraPosition.y=GetCameraPosition()
	PlayerPosition.x,PlayerPosition.z,PlayerPosition.y=GetTargetCamera()
	CameraUpVector.x,CameraUpVector.z,CameraUpVector.y=GetCameraUpVector()
	
	
	CameraVector.x=CameraPosition.x-PlayerPosition.x
	CameraVector.y=CameraPosition.y-PlayerPosition.y
	CameraVector.z=CameraPosition.z-PlayerPosition.z
	
	CameraDistance = math.sqrt(CameraVector.x*CameraVector.x+CameraVector.y*CameraVector.y+CameraVector.z*CameraVector.z)
	CameraNormalVector.x=CameraVector.x / CameraDistance
	CameraNormalVector.y=CameraVector.y / CameraDistance
	CameraNormalVector.z=CameraVector.z / CameraDistance
	
	DEFAULT_CHAT_FRAME:AddMessage("--- AutoZoomOut ---")
	DEFAULT_CHAT_FRAME:AddMessage("Camera position: " .. tostring(CameraPosition.x).. " " .. tostring(CameraPosition.y) .. " " .. tostring(CameraPosition.z))
	DEFAULT_CHAT_FRAME:AddMessage("Player position: " .. tostring(PlayerPosition.x).. " " .. tostring(PlayerPosition.y) .. " " .. tostring(PlayerPosition.z))	
	DEFAULT_CHAT_FRAME:AddMessage("Camera vector: " .. tostring(CameraNormalVector.x).. " " .. tostring(CameraNormalVector.y) .. " " .. tostring(CameraNormalVector.z))
	DEFAULT_CHAT_FRAME:AddMessage("CamUpvector: " .. tostring(CameraUpVector.x).. " " .. tostring(CameraUpVector.y) .. " " .. tostring(CameraUpVector.z))
	DEFAULT_CHAT_FRAME:AddMessage("Camera distance: " .. tostring(CameraDistance))
 	
end

function AutoZoomOut:GetDistance()

	local CameraPosition = {x=0,z=0,y=0}
	local PlayerPosition = {x=0,z=0,y=0}
	local CameraVector   = {x=0,z=0,y=0}
	local CameraDistance = 0
	
	CameraPosition.x,CameraPosition.z,CameraPosition.y=GetCameraPosition()
	PlayerPosition.x,PlayerPosition.z,PlayerPosition.y=GetTargetCamera()
		
	CameraVector.x=CameraPosition.x-PlayerPosition.x
	CameraVector.y=CameraPosition.y-PlayerPosition.y
	CameraVector.z=CameraPosition.z-PlayerPosition.z
	
	CameraDistance = math.sqrt(CameraVector.x*CameraVector.x+CameraVector.y*CameraVector.y+CameraVector.z*CameraVector.z)

	return CameraDistance
end

function AutoZoomOut:Toggle()
	if AutoZoomOutData.Enabled then
		AutoZoomOutData.Enabled=false
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Disabled")
	else 
		AutoZoomOutData.Enabled=true
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Enabled")
	end 
end

function AutoZoomOut:Debug()
	if AutoZoomOutData.Debug then
		AutoZoomOutData.Debug=false
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Debug disabled.")
	else 
		AutoZoomOutData.Debug=true
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Debug enabled.")
	end 
end

function AutoZoomOut:ToggleFreeze()
	if AutoZoomOutData.FreezeCamera then
		AutoZoomOutData.FreezeCamera=false
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Freeze mode disabled.")
	else 
		AutoZoomOutData.FreezeCamera=true
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Freeze mode enabled.")
	end 
end

function AutoZoomOut:Help()
	DEFAULT_CHAT_FRAME:AddMessage("--- AutoZoomOut ---")
	DEFAULT_CHAT_FRAME:AddMessage("SlashCommands are:")
	DEFAULT_CHAT_FRAME:AddMessage("/azo h   for this Help.")
	DEFAULT_CHAT_FRAME:AddMessage("/azo t   to toggle the Status.")
	DEFAULT_CHAT_FRAME:AddMessage("/azo p   to print the current Positions.")
	DEFAULT_CHAT_FRAME:AddMessage("/azo d   to toggle the debug Mode.")
	DEFAULT_CHAT_FRAME:AddMessage("- Don't mess with these -")
	DEFAULT_CHAT_FRAME:AddMessage("/azo sd  to set your Distance. (Default: 100)")
	DEFAULT_CHAT_FRAME:AddMessage("/azo ss  to set your Sensitivity. (Default: 3)")
	DEFAULT_CHAT_FRAME:AddMessage("/azo sc  to set your Cycledelay. (Default: 10)")
	DEFAULT_CHAT_FRAME:AddMessage("/azo sc  to set the Camera to a specified point. (eg. /azo sp 1 1 1  Format is x z y!")
	DEFAULT_CHAT_FRAME:AddMessage("/azo f   to toggle freeze Mode.")
	DEFAULT_CHAT_FRAME:AddMessage("Distance is set to "..tostring(AutoZoomOutData.Distance))
	DEFAULT_CHAT_FRAME:AddMessage("Sensitivity is set to "..tostring(AutoZoomOutData.Sensitivity))
	DEFAULT_CHAT_FRAME:AddMessage("CycleDelay is set to "..tostring(AutoZoomOutData.CycleDelay))
	if AutoZoomOutData.Debug then
		DEFAULT_CHAT_FRAME:AddMessage("Debugmode is currently enabled.")
	else
		DEFAULT_CHAT_FRAME:AddMessage("Debugmode is currently disabled.")
	end
	if AutoZoomOutData.Enabled then
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut is currently enabled.")
	else
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut is currently disabled.")
	end
	
end


function AutoZoomOut:SetCamera()
	local CameraPosition = {x=0,z=0,y=0}
	local PlayerPosition = {x=0,z=0,y=0}
	local CameraUpVector = {x=0,z=0,y=0}
	local CameraVector   = {x=0,z=0,y=0}
	local CameraNormalVector  = {x=0,z=0,y=0}
	local NewCameraPosition = {x=0,z=0,y=0}
	local CameraDistance = 0
	
	
	CameraPosition.x,CameraPosition.z,CameraPosition.y=GetCameraPosition()
	PlayerPosition.x,PlayerPosition.z,PlayerPosition.y=GetTargetCamera()
	CameraUpVector.x,CameraUpVector.z,CameraUpVector.y=GetCameraUpVector()
	
	
	CameraVector.x=CameraPosition.x-PlayerPosition.x
	CameraVector.y=CameraPosition.y-PlayerPosition.y
	CameraVector.z=CameraPosition.z-PlayerPosition.z
	
	CameraDistance = math.sqrt(CameraVector.x*CameraVector.x+CameraVector.y*CameraVector.y+CameraVector.z*CameraVector.z)
	CameraNormalVector.x=CameraVector.x / CameraDistance
	CameraNormalVector.y=CameraVector.y / CameraDistance
	CameraNormalVector.z=CameraVector.z / CameraDistance
    
	NewCameraPosition.x = PlayerPosition.x + AutoZoomOutData.Distance * CameraNormalVector.x
	NewCameraPosition.y = PlayerPosition.y + AutoZoomOutData.Distance * CameraNormalVector.y
	NewCameraPosition.z = PlayerPosition.z + AutoZoomOutData.Distance * CameraNormalVector.z
   
	if math.abs(CameraDistance-AutoZoomOutData.Distance)> AutoZoomOutData.Sensitivity then   
		if AutoZoomOutData.Debug then
			DEFAULT_CHAT_FRAME:AddMessage("Camera position: " .. tostring(CameraPosition.x).. " " .. tostring(CameraPosition.y) .. " " .. tostring(CameraPosition.z))
			DEFAULT_CHAT_FRAME:AddMessage("Player position: " .. tostring(PlayerPosition.x).. " " .. tostring(PlayerPosition.y) .. " " .. tostring(PlayerPosition.z))	
			DEFAULT_CHAT_FRAME:AddMessage("Camera vector: " .. tostring(CameraNormalVector.x).. " " .. tostring(CameraNormalVector.y) .. " " .. tostring(CameraNormalVector.z))
			DEFAULT_CHAT_FRAME:AddMessage("Camera distance: " .. tostring(CameraDistance))
		end
		SetCameraPosition(NewCameraPosition.x,NewCameraPosition.z,NewCameraPosition.y)
    end
end 

function AutoZoomOut:CalcDiff()
	local CurrentDistance=AutoZoomOut:GetDistance()
	local SetCam=false
	if AutoZoomOutData.Debug then
		DEFAULT_CHAT_FRAME:AddMessage("Difference: " .. tostring(CurrentDistance-AZOLastDistance))
	end
	if CurrentDistance-AZOLastDistance>AutoZoomOutData.Sensitivity and math.abs(AutoZoomOutData.Distance-CurrentDistance)>10 then
		SetCam=true
	end
	AZOLastDistance=CurrentDistance
	return SetCam
end

function AutoZoomOut:GetWords(str)
	local ret = {}
	local pos = 0
	while(true) do
		local word
		_, pos, word = string.find(str, "^ *([^%s]+) *", pos+1)
		if(not word) then
			return ret
		end
		table.insert(ret, word)
	end
end

function AutoZoomOut:SetDistance(value)
	assert(tonumber(value), "AutoZoomOut: Invalid input: "..value.." is not a number! Try again.");
	local TempDistance = tonumber(value)
	if TempDistance>1000 or TempDistance<0 then
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Distance " .. TempDistance .." out of range. Try a value between 0 and 1000.")
	else
		AutoZoomOutData.Distance=TempDistance
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Distance set to " .. TempDistance..".")
	end
end

function AutoZoomOut:SetSensitivity(value)
	assert(tonumber(value), "Invalid input: "..value.." is not a number! Try again.");
	local TempSensitivity = tonumber(value)
	if TempSensitivity>100 or TempSensitivity<0 then
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Sensitivity " .. TempSensitivity .." out of range. Try a value between 0 and 100.")
	else
		AutoZoomOutData.Sensitivity=TempSensitivity
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Sensitivity set to " .. TempSensitivity ..".")
	end
end

function AutoZoomOut:SetCycleDelay(value)
	assert(tonumber(value), "Invalid input: "..value.." is not a number! Try again.");
	local TempDelay = tonumber(value)
	if TempDelay>100 or TempDelay<0 then
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Cycledelay " .. TempDelay .." out of range. Try a value between 0 and 100.")
	else
		AutoZoomOutData.CycleDelay=TempDelay
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Cycledelay set to " .. TempDelay ..".")
	end
end

function AutoZoomOut:SetCamPosition(Pointx, Pointz, Pointy)
	SetCameraPosition(Pointx, Pointz, Pointy)
end

function AutoZoomOut:SlashCommand(Text)
	local var =string.lower(Text)
	local Strings = AutoZoomOut:GetWords(var)
	if Strings[1]==nil then
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Unknown command '" .. Text .."'. Try /azo h for help.")	
		return
	end
	if Strings[1]=="h" then
		AutoZoomOut:Help()
	elseif Strings[1]=="p" then
		AutoZoomOut:Print()
	elseif Strings[1]=="t" then 
		AutoZoomOut:Toggle()
	elseif Strings[1]=="d" then
		AutoZoomOut:Debug()
	elseif Strings[1]=="sd" then
		if Strings[2]==nil then
			DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Please specify a distance. (Eg. /azo sd 100)")	
		else
			AutoZoomOut:SetDistance(Strings[2])
		end
	elseif Strings[1]=="ss" then
		if Strings[2]==nil then
			DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Please specify a sensitivity. (Eg. /azo ss 3)")	
		else
			AutoZoomOut:SetSensitivity(Strings[2])
		end
	elseif Strings[1]=="sc" then
		if Strings[2]==nil then
			DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Please specify a Delay. (Eg. /azo sc 10)")	
		else
			AutoZoomOut:SetCycleDelay(Strings[2])
		end			
	elseif Strings[1]=="sp" then 
		if Strings[2]==nil or Strings[3]==nil or Strings[4]==nil then
			DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Please specify a complete set of coordinates. (Eg. /azo sp 1 1 1)")	
		else
			AutoZoomOut:SetCamPosition(Strings[2],Strings[3],Strings[4])
		end				
	elseif Strings[1]=="f" then
		AutoZoomOut:ToggleFreeze()
	else
		DEFAULT_CHAT_FRAME:AddMessage("AutoZoomOut: Unknown command '" .. Text .."'. Try /azo h for help.")	
	end
end

function AutoZoomOut:OnUpdate(self)	
	if AutoZoomOutData==nil then
		return
	end
	
	if AutoZoomOutData.Enabled then
		if AutoZoomOutData.FreezeCamera then
			AutoZoomOut:SetCamera()
		else
			AZOCounter = AZOCounter+1
			if AZOCounter> AutoZoomOutData.CycleDelay	then
				if not AutoZoomOut:IsInHouse() then
					if AutoZoomOut:CalcDiff() then
						AutoZoomOut:SetCamera()
					end
				end
			AZOCounter=0
			end
		end
	end
end

